#include "main.h"
extern int debug_flag, file_flag;

int get_page( struct in_addr tmp , char *out,   struct sockaddr_in dest_addr , 
	      char * page_name , int parsestr(char * , char *) )
{
  int flags , retval, sockfd;
  int len, bytes_sent, bytes_recvd,con , tot_bytes=0;
  long int t;
  struct timeval tv;
  fd_set readfds;
  char tmpstr[100];
  char getmsg[50];
  FILE *web_out=NULL;
  sprintf(getmsg,"GET /%s\n\n\n\n\n\n",page_name);
  
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) 
    {
      strcat(out,"Error opening sockfd.\n");
      close(sockfd);
      return 1;
    }
  
  if ( (flags = fcntl(sockfd,F_GETFL,0)) < 0 ) { 
    strcat(out,"Error getting flags from sockets.\n");
    close(sockfd);
    return 1;
  }     

  // non-blocking connect()s
  (void) fcntl(sockfd,F_SETFL,flags|O_NONBLOCK);      
  con=connect(sockfd, (struct sockaddr *)&dest_addr,
	      sizeof(struct sockaddr));
  t=timenow();
  while ( (timenow()-t< (CONN_TIMEOUT*1000)) && (errno==EINPROGRESS|| errno==EALREADY) ) { 
    con=connect(sockfd, (struct sockaddr *)&dest_addr,
		sizeof(struct sockaddr)) ; 
    sleep(1);
  }

  if (errno!=EISCONN) 
    {
      if (debug_flag==2) {
	char err[80];
	sprintf(err,"NO Webpage on %s - connect_time=%ld ",inet_ntoa(tmp) , timenow()-t);
          if (errno==ETIMEDOUT || errno==EINPROGRESS || errno==EALREADY)
            strcat(err,"Connection timed out\n");
          else if (errno==ECONNREFUSED)
            strcat(err,"Connection refused\n");
          else strcat(err,"Unknown error\n");
          strcat(out,err);
      }
      close(sockfd);
      return 1;
    }

  if (debug_flag==1 && (strcmp(page_name,"")==0) ) {
    strcpy(out,"-----------------------------\n");
    sprintf(tmpstr,"Port 80 found open on %s - connect_time=%ld\n" , 
	    inet_ntoa(tmp) , timenow()-t);
    strcat(out,tmpstr);
  }
  
  len = strlen(getmsg);
  
  if ((bytes_sent = send(sockfd, getmsg,len, 0)) == -1)
    {
      perror("send");
      if (debug_flag==1) strcat(out,"Error on send.\n");
      close(sockfd);
      return 1;
    }
  
  if ( (flags = fcntl(sockfd,F_GETFL,0)) < 0 ) { 
    if (debug_flag==1) 
      strcat(out,"Error getting flags from sockets.\n");
    close(sockfd);
    return 1;
  }     
  (void) fcntl(sockfd,F_SETFL,flags&!O_NONBLOCK);    
  
  /**** Code to ensure that recv does not block */
  tv.tv_sec = RECV_TIMEOUT;
  tv.tv_usec =  (int) (RECV_TIMEOUT*1000) %1000;
  
  FD_ZERO(&readfds);
  FD_SET(sockfd, &readfds);
  
  // don't care about writefds and exceptfds:
  retval = select(sockfd+1, &readfds, NULL, NULL, &tv) ;
    
  if (retval==0)
    {
      if (debug_flag==1) {
	sprintf(tmpstr,"Timeout waiting for page %s from %s.\n",page_name,inet_ntoa(tmp));
	strcat(out,tmpstr);
      }
      close(sockfd);
      return 1;
    }

  if (retval!=0 && retval !=1)
    {
      if (debug_flag==1) strcat(out,"Error with select.\n");
      close(sockfd);
      return 1;
    }
  
  // else retval = 1 and socket is ready for reading  
  {  
    char buf[MAXDATASIZE+1]; 
    
    if ((bytes_recvd=recv(sockfd, buf, 199, 0)) == -1) 
      {
	if (debug_flag==2) strcat(out,"recv() error.\n");
	close(sockfd);
	return 1;
      }
    if (bytes_recvd==0) 
      {
	if (debug_flag==1) {
	  sprintf(tmpstr,"Null page %s from %s.\n",
		  page_name,inet_ntoa(tmp));
	  strcat(out,tmpstr);
	}
	
	close(sockfd);
	return 1;
      }
    if (strcmp(page_name,"")==0) {
      if (debug_flag==0) strcat(out,"-----------------------------\n");
      sprintf(tmpstr,"Webpage found on %s", inet_ntoa(tmp));
      strcat(out,tmpstr);
    }
    else if (debug_flag==1)  {
      sprintf(tmpstr,"Webpage %s found.",page_name);
      strcat(out,tmpstr);
    }
    if (strcmp(page_name,"")==0) page_name = "htm";

    if (file_flag==1 && debug_flag==1 ) {
      sprintf(tmpstr," Dumping to %s.%s",inet_ntoa(tmp),page_name);
      strcat(out,tmpstr);
    }
    
    if (debug_flag==0 && strcmp(page_name,"htm")!=0 ); else  strcat(out,"\n");
    
    sprintf(tmpstr,"%s.%s",inet_ntoa(tmp),page_name);
    if ( file_flag==1 && (web_out=fopen(tmpstr, "w"))==NULL )
      {      
	if (debug_flag==1) strcat(out,"Can't open file for writing.\n");
      }
    
    
    tot_bytes+=bytes_recvd;
    buf[tot_bytes] = '\0';
    /*** End non-blocking recv code */
    
    tv.tv_sec = RECV_TIMEOUT;
    tv.tv_usec =  (int) (RECV_TIMEOUT*1000) %1000;
    
    while(( retval=select(sockfd+1, &readfds, NULL, NULL, &tv)) ==1)
      {
	if ((bytes_recvd=recv(sockfd, buf+tot_bytes, MAXDATASIZE-1, 0)) == -1) 
	  {
	    strcat(out,"Error recv'ing data failed\n");
	    break;
	  }
	if (tot_bytes+bytes_recvd>MAXDATASIZE) {
	  if (debug_flag==1) strcat(out,"Page too big for allocated space.\n");
	  break;
	}
	tot_bytes+=bytes_recvd;
	buf[tot_bytes] = '\0';
	if (bytes_recvd==0) break;
	tv.tv_sec = RECV_TIMEOUT;
	tv.tv_usec =  (int) (RECV_TIMEOUT*1000) %1000;
      } 
    
    if (retval==0)
      {
	if (debug_flag==1) {
	  sprintf(tmpstr,"Timeout waiting for page %s from %s.\n",
		  page_name,inet_ntoa(tmp));
	  strcat(out,tmpstr);
	}
	close(sockfd);
	return 1;
      }

    if (retval!=0 && retval !=1)
      {
	if (debug_flag==1) strcat(out,"Error with select.\n");
	close(sockfd);
	return 1;
      }
        
    // retval=1 so we have terminated normally
    
    if(file_flag==1 && web_out!=NULL)  {
      fprintf(web_out,"%s", buf);
      fclose(web_out);
    }
    
    close(sockfd); 
    return (parsestr(buf,out)!=0);
    
  }  
}
