#include "main.h"
#include <pthread.h>
static pthread_mutex_t     mutex = PTHREAD_MUTEX_INITIALIZER;
static int mask;
static int curr=0;
static long int basehost;

extern int debug_flag , file_flag , pass_flag;

void scan(char *host, int m, int thr)
{
  pthread_t thread;
  int rc, i;
  struct in_addr tmp;
  char out[34]="";
  mask=m;
  basehost= inet_network(host) & (long) (pow(2,31)-pow(2,mask)+(1<<31) ) ;
  tmp.s_addr = htonl(basehost);

  tobin(inet_network(host),out);
  tobin(pow(2,31)-pow(2,mask)+(1<<31),out);
  /* printf("host - %s\n",host );
     printf("inet - %s\n",out); */
    printf("mask - %s\n",out); 
    printf("base host - %s\n",inet_ntoa(tmp)); 
  
  for (i=1;i<=thr;i++)
    {
	  rc = pthread_create(&thread, NULL, scanhost, NULL );
	  if (rc){
	    if (debug_flag==1) 
	      printf("ERROR; return code from pthread_create() is %d\n", rc);
	    i--;
	  }
	  /* else printf("Thread %d created successfully\n",i); */
	  
    }

  if (debug_flag==1) {
    printf("-----------------------------\n");
    printf("Main completed, waiting for threads to finish\n");
  }
  
  pthread_exit(NULL); 
  //exit(1);
}

void *scanhost(void * dummy)
{
  int rc, my_inet, t;
  struct in_addr tmp;
  char out[600];
  struct sockaddr_in dest_addr; // connector's address information 

  while (1) {

    strcpy(out,"");
    rc = pthread_mutex_lock(&mutex);
    if (rc) perror("Mutex locking");
    
    if (curr<pow(2,mask) )
      {
	my_inet=curr;
	curr++;
      }
    else
      {
	rc = pthread_mutex_unlock(&mutex);
	if (rc) perror("Mutex unlocking");
	/*  printf("thread exiting\n"); */ 
	pthread_exit(NULL);
      }
    rc = pthread_mutex_unlock(&mutex);
    if (rc) perror("Mutex unlocking");

    tmp.s_addr = htonl(basehost+my_inet);    
    dest_addr.sin_family = AF_INET;         // host byte order
    dest_addr.sin_port = htons(80);     // short, network byte order
    dest_addr.sin_addr.s_addr = htonl(basehost+my_inet);
    memset(&(dest_addr.sin_zero), '\0', 8); // zero the rest of the struct
    /* printf("I have host %s\n",inet_ntoa(tmp)); */
    t=get_page(tmp,out, dest_addr, "" , parse_webramp) ;
    
    if (pass_flag==1 && t==0) {
      strcat(out,"WebRamp installation found\n");
      if (get_page(tmp,out, dest_addr, "avconn1.htm" , parse_pass1) ==0 )
      {
        if (get_page(tmp,out, dest_addr, "avconn2.htm" , parse_pass1)!=0)
          get_page(tmp,out, dest_addr, "avconn2.htm" , parse_pass1);
        if (get_page(tmp,out, dest_addr, "avconn3.htm" , parse_pass1)!=0)
          get_page(tmp,out, dest_addr, "avconn3.htm" , parse_pass1);
      }
      else if (get_page(tmp,out, dest_addr, "expressi.htm" , parse_pass2) ==0 ) ;
      else if (get_page(tmp,out, dest_addr, "express.htm" , parse_pass3) ==0 ) ; 
      else  {
	strcat(out,"Get_pass failed once. Trying again.\n");
	if (get_page(tmp,out, dest_addr, "avconn1.htm" , parse_pass1) ==0 )
      {
        if (get_page(tmp,out, dest_addr, "avconn2.htm" , parse_pass1)!=0)
          get_page(tmp,out, dest_addr, "avconn2.htm" , parse_pass1);
        if (get_page(tmp,out, dest_addr, "avconn3.htm" , parse_pass1)!=0)
          get_page(tmp,out, dest_addr, "avconn3.htm" , parse_pass1);
      }
	else if (get_page(tmp,out, dest_addr, "expressi.htm" , parse_pass2) ==0 ) ;
	else if (get_page(tmp,out, dest_addr, "express.htm" , parse_pass3) ==0 ) ; 
	else  strcat(out,"Get_pass failed. Rerun on specific IP or retrieve manually\n");
      } 
    }
    
    printf("%s",out);
    continue;
  }
}

void tobin(long in,  char * out) {
  int i;
  for(i=0;i<32;i++)
    {
      if (in& 1<<31 )
	out[i]='1';
      else out[i]='0';
      in=in<<1;
    }
  out[32]='\0';
  return;
}

long int timenow()
{
  struct timeval Time;
  gettimeofday(&Time, (__timezone_ptr_t) NULL);
  return  (Time.tv_sec * 1000) + (Time.tv_usec/1000);
  // return Time.tv_nsec;
}

