#include "main.h"

char * host2ip(char *host);
int debug_flag, file_flag, pass_flag;

int main(int argc , char ** argv)
{
  int mask=24;
  char host[15];
  int threads=DEFAULT_THREADS;
  char opt;
  char * valid = "hdfnm:t:";

  debug_flag=0; file_flag=0; pass_flag=1;

  while ((opt = getopt(argc,argv, valid))  !=-1)
    {
      switch (opt) {
      case 'h': 
	displayhelp();
	break;
      case 'd': 
	debug_flag=1;
	break;
      case 'n': 
	pass_flag=0;
	break;
      case 'f': 
	file_flag=1;
	break;
      case 't': 
	if ((threads=atoi(optarg)) ==0) {
	  fprintf(stderr,"Number of threads needs to be an integer\n");
	  exit(1);
	}
	break;
      case 'm': 
	if ((mask=atoi(optarg)) ==0 || mask>32 || mask <0) {
	  fprintf(stderr,"Number of bits in in scanned subnet. Needs to be an integer from 0 to 32\n");
	  exit(1);
	}
	break;
      }
    }

  if (argc-optind != 1) displayhelp();

  strcpy(host,host2ip(argv[optind]));
  printf("IP Address:  %s\n",host );
  if (debug_flag==1) printf("Scan Mask: %d\n",mask);
  scan(host, 32-mask, threads);
 
  return 0;

}

char * host2ip (char *host)
{
  struct hostent *h;
  
  if ((h=gethostbyname(host)) == NULL) {  // get the host info
    herror("gethostbyname");
    exit(1);
  }
  return  inet_ntoa(*((struct in_addr *)h->h_addr));  
} 

void displayhelp(void)
{
  printf("webrampscan v0.2 - programs to scan IP subnets for webpages, and optionally parse for\n");
  printf(" passwords from webramp installations.\n\n");
  printf("Usage - webrampscan [-hdfn] [-t #] [-m #]  hostname/ip \n\n");
  printf("-h  -displays this help\n");
  printf("-d  -enables debugging output\n");
  printf("-f  -saves all html files downloaded\n");
  printf("-n  -disables looking for passwords\n");
  printf("-t #  -sets number of threads (1-100)\n");
  printf("-m #  -sets number of bits in scan mask, eg. the default is 24\n");
  printf("\twhich specifies the subnet with 255 hosts\n");
  exit(0);
}
